library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package pk_counter is
  component counter is
    port(
      clk    : in std_logic;
      clear  : in std_logic;
      enable : in std_logic;

      count : out std_logic_vector(3 downto 0)
      );
  end component;
end package;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity counter is
  port(
    clk    : in std_logic;
    clear  : in std_logic;
    enable : in std_logic;

    count : out std_logic_vector(3 downto 0)
    );
end counter;

architecture synth of counter is
  signal s_counter : std_logic_vector(3 downto 0);
begin

  process (clk, clear, enable)
  begin
    if rising_edge(clk) then
      if clear = '1' then
        s_counter <= "0000";
      elsif enable = '1' then
        s_counter <= s_counter + 1;
      end if;
    end if;
  end process;

  count <= s_counter;

end;
