--HEX_2_7SEG

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package pk_hex27seg is
  component hex27seg is
    port(
      hex_in  : in  std_logic_vector(3 downto 0);
      seg_out : out std_logic_vector(6 downto 0)
      );
  end component;
end package;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity hex27seg is
  port(
    hex_in  : in  std_logic_vector(3 downto 0);
    seg_out : out std_logic_vector(6 downto 0)
    );
end hex27seg;


architecture synth of hex27seg is

--constants

--                 "abcdefg"
  constant cero    : std_logic_vector(6 downto 0) := "1000000"; --0000001 
  constant uno     : std_logic_vector(6 downto 0) := "1111001"; --1001111 
  constant dos     : std_logic_vector(6 downto 0) := "0100100"; --0010010 
  constant tres    : std_logic_vector(6 downto 0) := "0110000"; --0000110 
  constant cuatro  : std_logic_vector(6 downto 0) := "0011001"; --1001100 
  constant cinco   : std_logic_vector(6 downto 0) := "0010010"; --0100100 
  constant seis    : std_logic_vector(6 downto 0) := "0000010"; --0100000 
  constant siete   : std_logic_vector(6 downto 0) := "1011000"; --0001101 
  constant ocho    : std_logic_vector(6 downto 0) := "0000000"; --0000000 
  constant nueve   : std_logic_vector(6 downto 0) := "0010000"; --0000100 
  constant letra_A : std_logic_vector(6 downto 0) := "0001000"; --0001000 
  constant letra_B : std_logic_vector(6 downto 0) := "0000011"; --1100000  -- Es una b minuscula
  constant letra_C : std_logic_vector(6 downto 0) := "1000110"; --0110001 
  constant letra_D : std_logic_vector(6 downto 0) := "0100001"; --1000010  -- Es una d minuscula
  constant letra_E : std_logic_vector(6 downto 0) := "0000110"; --0110000 
  constant letra_F : std_logic_vector(6 downto 0) := "0001110"; --0111000 
  
begin

--***********
  seg_decoder:
--***********
  process (hex_in)
  begin
    case hex_in is
      when X"0" =>
        seg_out <= cero;
      when X"1" =>
        seg_out <= uno;
      when X"2" =>
        seg_out <= dos;
      when X"3" =>
        seg_out <= tres;
      when X"4" =>
        seg_out <= cuatro;
      when X"5" =>
        seg_out <= cinco;
      when X"6" =>
        seg_out <= seis;
      when X"7" =>
        seg_out <= siete;
      when X"8" =>
        seg_out <= ocho;
      when X"9" =>
        seg_out <= nueve;
      when X"A" =>
        seg_out <= letra_A;
      when X"B" =>
        seg_out <= letra_B;
      when X"C" =>
        seg_out <= letra_C;
      when X"D" =>
        seg_out <= letra_D;
      when X"E" =>
        seg_out <= letra_E;
      when X"F" =>
        seg_out <= letra_F;
    end case;
    
  end process;

end synth;
